<h1 align="center">JTS3ServerMod-dockerized</h1>

<p align="center">
  <a href="https://drone.nick-slowinski.de/NickSlowinski/JTS3ServerMod-dockerized" title="Build Status">
    <img alt="Status der veröffentlichten Version" src="https://img.shields.io/drone/build/NickSlowinski/JTS3ServerMod-dockerized?label=build%20%28released%29&logo=build%20%28released%29&server=https%3A%2F%2Fdrone.nick-slowinski.de">
    <img alt="Status der Entwickler-Version" src="https://img.shields.io/drone/build/NickSlowinski/JTS3ServerMod-dockerized/dev?label=build%20%28dev%29&logo=build%20%28released%29&server=https%3A%2F%2Fdrone.nick-slowinski.de">
  </a>
  <a href="https://hub.docker.com/r/nickslowinski/jts3servermod-dockerized" title="Docker Hub">
    <img alt="Docker Downloads" src="https://img.shields.io/docker/pulls/nickslowinski/jts3servermod-dockerized">
    <img alt="Docker Image Größe" src="https://img.shields.io/docker/image-size/nickslowinski/jts3servermod-dockerized/dev">
  </a>
</p>

## Was ist es? Und kann ich es essen?

Erstens: Nein, Sie können es nicht essen. Sie können es aber als dockerisierte Variante des [JTS3ServerMod](https://www.stefan1200.de/forum/index.php?topic=3.0) verwenden.  
JTS3ServerMod ist ein ziemlich perfekter Bot für Ihren TeamSpeak-Server – geschrieben in Java. Da einige Leute ein Docker-Image brauchen/wollen und der ursprüngliche Autor Stefan1200 keins zur Verfügung stellt, bin ich hier, um Ihnen zu helfen.

## Unterstützte Architekturen

- linux/amd64
- linux/arm/v6
- linux/arm/v7
- linux/arm64/v8

## Ausführen des Images

Sie können das Image wie jeden anderen Container ausführen, es stellt automatisch das erforderliche Voloume mit den Konfigurationsdateien bereit. Weitere Informationen zur Konfiguration des JTS3ServerMod finden Sie in den offiziellen Dokumentationen, entweder durch Einbinden des _documents_-Volumes oder durch den Besuch [der Online-Dokumentation](https://www.stefan1200.de/documentation/jts3servermod/readme_deutsch.html).

### Mögliches Volume-Mapping

| Volume    | Pfad im Container          | Beschreibung                                                                                                               |
| --------- | -------------------------- | -------------------------------------------------------------------------------------------------------------------------- |
| config    | `/JTS3ServerMod/config`    | Konfigurationsdateien                                                                                                      |
| documents | `/JTS3ServerMod/documents` | Dokumentationsdateien des Bots + Original _changelog.txt_ und _readme.txt_ (+deutsche Variante)                            |
| logs      | `/JTS3ServerMod/logs`      | Speicherort für Log-Dateien                                                                                                |
| plugins   | `/JTS3ServerMod/plugins`   | In diesem Verzeichnis können zusätzliche Plugins hochgeladen werden - bitte folgen Sie der Dokumentation des JTS3ServerMod |

### Beispiele (mit allen Volumes)

#### Ein Container mit benannten Volumes und festgelegten Namen

```
docker run --name jts3servermod-dockerized -v jts3_config:/JTS3ServerMod/config -v jts3_documents:/JTS3ServerMod/documents -v jts3_logs:/JTS3ServerMod/logs -v jts3_plugins:/JTS3ServerMod/plugins nickslowinski/jts3servermod-dockerized:dev
```

#### Ein Container mit gemounteten Volumes und festgelegten Namen

```
docker run --name jts3servermod-dockerized -v /ein/pfad/auf/dem/host/jts3_config:/JTS3ServerMod/config -v /ein/pfad/auf/dem/host/jts3_documents:/JTS3ServerMod/documents -v /ein/pfad/auf/dem/host/jts3_logs:/JTS3ServerMod/logs -v /ein/pfad/auf/dem/host/jts3_plugins:/JTS3ServerMod/plugins nickslowinski/jts3servermod-dockerized:dev
```

## Häufige Probleme

### Der Container stoppt sofort nach dem Start

Falls der Log-Auszug in etwa so aussieht wie der nachfolgende, **dann bedeutet dies nicht, dass das Image defekt ist!** Ihr müsst den Bot konfigurieren und erneut starten, solange Ihr keine Fehler in der Konfiguration begangen habt, startet der Bot erfolgreich.

```
JTS3ServerMod 6.5.7 (31.01.2020) Instance Manager started...
Operating System : Linux (version: 5.14.10-200.fc34.x86_64 / arch: amd64)
Used Java Version: 1.8.0_282 (path: /usr/lib/jvm/java-1.8-openjdk/jre)
Current directory: /JTS3ServerMod
Writing InstanceManager log file to: /JTS3ServerMod/JTS3ServerMod_InstanceManager.log
Loading InstanceManager config file from: /JTS3ServerMod/config/JTS3ServerMod_InstanceManager.cfg
bot1: Writing bot log file to: /JTS3ServerMod/JTS3ServerMod_server1.log
bot1: Virtual bot instance "bot1" starts now (build 6508)
bot1:
bot1: **********************************************************************************
bot1: It seems you never touched the config, check file config/server1/JTS3ServerMod_server.cfg
bot1: **********************************************************************************
bot1:
bot1: Unable to connect to Teamspeak 3 server at ts3.server.net!
bot1: java.net.UnknownHostException: ts3.server.net
bot1: Virtual bot instance "bot1" stopped
Stopping all bots, please wait...
```

### Fehler beim Laden der JTS3ServerMod InstanceManager Konfigurationsdatei

Beispiel Log-Auszug:

```
JTS3ServerMod 6.5.7 (31.01.2020) Instance Manager started...
Operating System : Linux (version: 5.10.17-v8+ / arch: aarch64)
Used Java Version: 1.8.0_282 (path: /usr/lib/jvm/java-1.8-openjdk/jre)
Current directory: /JTS3ServerMod
Writing InstanceManager log file to: /JTS3ServerMod/JTS3ServerMod_InstanceManager.log
JTS3ServerMod InstanceManager configuration file does not exists, check file path:
/JTS3ServerMod/config/JTS3ServerMod_InstanceManager.cfg
Error while loading the JTS3ServerMod InstanceManager config file, read error messages above to know more. Quitting now...
```

Dieser Fehler konnte bisher immer nachweislich auf veraltete Softwareversionen zurückgeführt werden. Um diesen Fehler zu beheben, muss nur das System, unter anderem auch Docker und dessen Abhängigkeiten, aktualisiert werden. Sollte der Fehler nach erfolgreicher Aktualisierung und einem anschließenden Systemneustart immer noch auftreten, so [eröffnet bitte ein Ticket](https://git.nick-slowinski.de/NickSlowinski/JTS3ServerMod-dockerized/issues/new).

## Hilfe bekommen

Bitte verwenden Sie den [Issue Tracker](https://git.nick-slowinski.de/NickSlowinski/JTS3ServerMod-dockerized/issues), um nach Ihrem Problem zu suchen (und verwenden Sie unterschiedliche Schlagwörter). Wenn Sie sichergestellt haben, dass Ihr Problem eindeutig ist, [erstellen Sie ein Ticket](https://git.nick-slowinski.de/NickSlowinski/JTS3ServerMod-dockerized/issues/new) und geben Sie hilfreiche Informationen wie Protokolle, was Sie getan haben, nützliche Teile deiner Konfiguration usw. an.  
Wenn Sie eine Sicherheitslücke gefunden haben, kontaktieren Sie mich bitte privat per E-Mail unter nick@nick-slowinski.de (und verschlüsseln Sie die Nachricht mit [mein PGP-Schlüssel](https://keys.openpgp.org/search?q=nick%40nick-slowinski.de) wenn möglich). Sicherheitslücken werden priorisiert und nach der Veröffentlichung eines Fixes öffentlich bekannt gegeben.

## Beitragen

Beiträge zu diesem Projekt sind herzlich willkommen. Wenn Sie einen Weg gefunden haben, dieses Projekt zu verbessern, öffnen Sie bitte ein [Ticket](https://git.nick-slowinski.de/NickSlowinski/JTS3ServerMod-dockerized/issues/new) und beschreiben Sie, was Sie erreichen möchten (damit Sie keine Zeit verschwenden, wenn Ihr Vorschlag außerhalb des Projektrahmens liegt).  
Ein vollständiger Leitfaden für Mitwirkende wird zu einem späteren Zeitpunkt veröffentlicht.

## Autoren

- [Maintainer](MAINTAINERS)
- [Mitwirkende](CONTRIBUTORS)

## Lizenz

Dieses Projekt ist unter der _GNU General Public License_ lizenziert. Den vollständigen englischen Lizenztext finden Sie in der [LIZENZ](LICENSE)-Datei.

## Häufig gestellte Fragen

### Planen Sie, Images für andere Architekturen zu veröffentlichen?

Vorerst nicht, aber wenn jemand eine andere Architektur anfordert (über den Issue Tracker), werde ich prüfen, was ich tun kann.

### Warum verwenden Sie openjdk8 und nicht 11?

Ich möchte das Image so klein wie möglich halten, daher wurde OpenJDK 8 über 11 gewählt. Solange OpenJDK 8 unterstützt wird und für dieses Projekt ausreichend ist, wird es verwendet.

### Wird die JTS3ServerMod Hosting Edition unterstützt?

Nicht im Moment. Ich kann ein Image dafür erstellen (Stefan1200 stellt die Downloads dafür bereit), aber es gibt keine Möglichkeit, es zu testen, da ich keinen Lizenzschlüssel dafür habe.

### Welche Änderungen wurden am ursprünglichen Code vorgenommen?

1. Es wurden folgende Dateien in den Unterordner _documents_ verschoben: `changelog.txt`, `readme.txt`, `readme_deutsch.txt`
2. Die Standard-Log-Pfade in der `JTS3ServerMod_InstanceManager.cfg` wurden angepasst, sodass die Logs über ein Volume zugänglich sind.

Die Anpassungen waren nötig, damit die entsprechenden Dateien über Volumes zugänglich gemacht werden können, ohne die `.jar`-Datei oder andere kritische Dateien mit zu „veröffentlichen“.
